/*
 *      $Source: /usr/local/libdata/cvs/c-lib/libcompat/test.c,v $
 *      $Revision: 1.1 $
 *      $Date: 1997/12/14 10:35:56 $
 *
 *      Copyright (C) 1997 by Alain Magloire <alainm@rcsm.ee.mcgill.ca>.
 *
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License as
 *      published by the Free Software Foundation; either version 2 of
 *      the License, or (at your option) any later version. It can be
 *      redistribute also under the terms of GNU Library General
 *      Public Lincense.
 *
 *      This program is distributed in the hope that it will be
 *      useful, but WITHOUT ANY WARRANTY; without even the implied
 *      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *      PURPOSE. See the GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public
 *      License along with this program; if not, write to the Free
 *      Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 *      USA.
 *
 */

#include <stdio.h>

int
main(int argc, char **argv)
{
    char      holder[100];
    int       i;

   printf("Suite of test for snprintf:\n");
   printf("a_format\n");
   printf("printf() format\n");
   printf("snprintf() format\n\n");

   /* Checking the field widths */

    printf("/%%d/, 336\n");
    snprintf(holder, sizeof holder, "/%d/\n", 336);
    printf("/%d/\n", 336);
    printf("%s\n", holder);

    printf("/%%2d/, 336\n");
    snprintf(holder, sizeof holder, "/%2d/\n", 336);
    printf("/%2d/\n", 336);
    printf("%s\n", holder);

    printf("/%%10d/, 336\n");
    snprintf(holder, sizeof holder, "/%10d/\n", 336);
    printf("/%10d/\n", 336);
    printf("%s\n", holder);

    printf("/%%-10d/, 336\n");
    snprintf(holder, sizeof holder, "/%-10d/\n", 336);
    printf("/%-10d/\n", 336);
    printf("%s\n", holder);

    /* floating points */

    printf("/%%f/, 1234.56\n");
    snprintf(holder, sizeof holder, "/%f/\n", 1234.56);
    printf("/%f/\n", 1234.56);
    printf("%s\n", holder);

    printf("/%%e/, 1234.56\n");
    snprintf(holder, sizeof holder, "/%e/\n", 1234.56);
    printf("/%e/\n", 1234.56);
    printf("%s\n", holder);

    printf("/%%4.2f/, 1234.56\n");
    snprintf(holder, sizeof holder, "/%4.2f/\n", 1234.56);
    printf("/%4.2f/\n", 1234.56);
    printf("%s\n", holder);

    printf("/%%3.1f/, 1234.56\n");
    snprintf(holder, sizeof holder, "/%3.1f/\n", 1234.56);
    printf("/%3.1f/\n", 1234.56);
    printf("%s\n", holder);

    printf("/%%10.3f/, 1234.56\n");
    snprintf(holder, sizeof holder, "/%10.3f/\n", 1234.56);
    printf("/%10.3f/\n", 1234.56);
    printf("%s\n", holder);

    printf("/%%10.3e/, 1234.56\n");
    snprintf(holder, sizeof holder, "/%10.3e/\n", 1234.56);
    printf("/%10.3e/\n", 1234.56);
    printf("%s\n", holder);

    printf("/%%+4.2f/, 1234.56\n");
    snprintf(holder, sizeof holder, "/%+4.2f/\n", 1234.56);
    printf("/%+4.2f/\n", 1234.56);
    printf("%s\n", holder);

    printf("/%%010.2f/, 1234.56\n");
    snprintf(holder, sizeof holder, "/%010.2f/\n", 1234.56);
    printf("/%010.2f/\n", 1234.56);
    printf("%s\n", holder);

#define BLURB "Outstanding acting !"
    /* strings precisions */

    printf("/%%2s/, \"%s\"\n", BLURB);
    snprintf(holder, sizeof holder, "/%2s/\n", BLURB);
    printf("/%2s/\n", BLURB);
    printf("%s\n", holder);

    printf("/%%22s/ %s\n", BLURB);
    snprintf(holder, sizeof holder, "/%22s/\n", BLURB);
    printf("/%22s/\n", BLURB);
    printf("%s\n", holder);

    printf("/%%22.5s/ %s\n", BLURB);
    snprintf(holder, sizeof holder, "/%22.5s/\n", BLURB);
    printf("/%22.5s/\n", BLURB);
    printf("%s\n", holder);

    printf("/%%-22.5s/ %s\n", BLURB);
    snprintf(holder, sizeof holder, "/%-22.5s/\n", BLURB);
    printf("/%-22.5s/\n", BLURB);
    printf("%s\n", holder);

    /* see some flags */

    printf("%%x %%X %%#x, 31, 31, 31\n");
    snprintf(holder, sizeof holder, "%x %X %#x\n", 31, 31, 31);
    printf("%x %X %#x\n", 31, 31, 31);
    printf("%s\n", holder);

    printf("**%%d**%% d**%% d**, 42, 42, -42\n");
    snprintf(holder, sizeof holder, "**%d**% d**% d**\n", 42, 42, -42);
    printf("**%d**% d**% d**\n", 42, 42, -42);
    printf("%s\n", holder);

    /* other flags */

    printf("/%%g/, 31.4\n");
    snprintf(holder, sizeof holder, "/%g/\n", 31.4);
    printf("/%g/\n", 31.4);
    printf("%s\n", holder);

    printf("/%%.6g/, 31.4\n");
    snprintf(holder, sizeof holder, "/%.6g/\n", 31.4);
    printf("/%.6g/\n", 31.4);
    printf("%s\n", holder);

    printf("/%%.1G/, 31.4\n");
    snprintf(holder, sizeof holder, "/%.1G/\n", 31.4);
    printf("/%.1G/\n", 31.4);
    printf("%s\n", holder);

    printf("abc%%n\n");
    printf("abc%n", &i);
    printf("%d\n", i);
    snprintf(holder, sizeof holder, "abc%n", &i);
    printf("%s", holder);
    printf("%d\n\n", i);

    printf("%%*.*s --> 10.10\n");
    snprintf(holder, sizeof holder, "%*.*s\n", 10, 10, BLURB);
    printf("%*.*s\n", 10, 10, BLURB);
    printf("%s\n", holder);

    printf("%%%%%%%%\n");
    snprintf(holder, sizeof holder, "%%%%\n");
    printf("%%%%\n");
    printf("%s\n", holder);

#define BIG "Hello this is a too big string for the buffer"

    printf("A buffer to small of 10, trying to put this:\n");
    printf("<%%>, %s\n", BIG);
    i = snprintf(holder, 10, "%s\n", BIG);
    printf("<%s>\n", BIG);
    printf("<%s>\n", holder);

    return 0;
}
