/*
 *      $Source: /usr/local/libdata/cvs/simons/petidomo/src/htmlconf/handleconfpage.c,v $
 *      $Revision: 1.8 $
 *      $Date: 1998/06/01 21:36:42 $
 *
 *      Copyright (C) 1996 by Peter Simons, Germany
 *      All rights reserved.
 */

#include <errno.h>

#include <petidomo.h>
#include <cgi.h>

extern cgi_info      ci;
extern form_entry *  form_parameter;

void printMainPage(void);
void handleBlanks(char **);

void
handleConfPage(void)
{
    FILE *     fh;
    char *     Hostname = parmval(form_parameter, "Hostname");
    char *     password = parmval(form_parameter, "password");
    char *     newpassword = parmval(form_parameter, "newpassword");
    char *     newpassword2 = parmval(form_parameter, "newpassword2");
    char *     mta = parmval(form_parameter, "mta");
    char *     mta_options = parmval(form_parameter, "mta_options");
    char *     detachimmediately = parmval(form_parameter, "detachimmediately");
    char *     showstats = parmval(form_parameter, "showstats");

    /* Do consistency checks. */

    if (isValidAdminPassword(password, NULL) == FALSE) {
	puts("<H1 ALIGN=center>Access denied!</H1>");
	puts("The password you entered does not authorize you to edit the");
	puts("master config file, I am afraid.");
	return;
    }

    if (strcasecmp(newpassword, newpassword2) != 0) {
	puts("<H3>ERROR</H1>");
	puts("You mis-typed the administrator password. Please use the \n");
	puts("\"previous page\" function of your browser to edit the \n");
	puts("entries in the form again.<P>");
	return;
    }

    if (*Hostname == '\0') {
	puts("<H3>ERROR</H1>");
	puts("You didn't specify a hostname for Petidomo. Please use the \n");
	puts("\"previous page\" function of your browser to edit the \n");
	puts("entry in the form again.<P>");
	return;
    }

    if (*mta == '\0') {
	puts("<H3>ERROR</H1>");
	puts("You didn't specify a mail transport agent (MTA) for Petidomo. Please \n");
	puts("use the \"previous page\" function of your browser to edit the \n");
	puts("entry in the form again.<P>");
	return;
    }

    handleBlanks(&newpassword);
    handleBlanks(&mta_options);

    /* Write the new config file back. */

    fh = fopen("etc/petidomo.conf", "w");
    if (fh == NULL) {
	puts("<H3>ERROR</H1>");
	puts("Opening the master config file failed with the following error:<P>\n");
	printf("<CENTER><CODE>%s</CODE></CENTER><P>\n", strerror(errno));
	puts("Please contact the administrator with this problem.<P>\n");
	return;
    }
    fprintf(fh, "#\n");
    fprintf(fh, "# Petidomo Master Config File\n");
    fprintf(fh, "# generated automatically by petidomoconf\n");
    fprintf(fh, "#\n");
    fprintf(fh, "Hostname\t\t%s\n", Hostname);
    if (*newpassword == '\0')
      fprintf(fh, "AdminPassword\t\t%s\n", password);
    else
      fprintf(fh, "AdminPassword\t\t%s\n", newpassword);
    fprintf(fh, "MTA\t\t\t%s\n", mta);
    if (*mta_options == '\0')
      fprintf(fh, "#MTA_Options\t\t\"-odq -f%%s\n");
    else
      fprintf(fh, "MTA_Options\t\t%s\n", mta_options);
    if (*detachimmediately == '\0')
      fprintf(fh, "#DetachImmediately\tno\n");
    else
      fprintf(fh, "DetachImmediately\t%s\n", detachimmediately);
    if (*showstats == '\0')
      fprintf(fh, "#ShowStatistics\t\tno\n");
    else
      fprintf(fh, "ShowStatistics\t\t%s\n", showstats);
    fclose(fh);

    /* If all was successful, show the main page again. */

    printMainPage();
    puts("<H3>Success</H1>");
    puts("The new configuration has been set successfully.<P>");
}
