/*
 *      $Source: /usr/local/libdata/cvs/simons/petidomo/src/htmlconf/htmlconf.c,v $
 *      $Revision: 1.11 $
 *      $Date: 1998/06/01 17:19:28 $
 *
 *      Copyright (C) 1996 by Peter Simons, Germany
 *      All rights reserved.
 */

#include <sys/types.h>
#include <sys/stat.h>

#include <petidomo.h>
#include <cgi.h>

void printMainPage(void);
void handleMainPage(void);
void handleConfPage(void);
void handleListSelect(void);
void handleListConfPage(void);
void handleCreateListPage(void);
void handleRemoveListPage(void);
void SetUIDPetidomo(void);

cgi_info      ci;
form_entry *  form_parameter;

int
main(int argc, char * argv[])
{
    const struct PD_Config * MasterConfig;
    char *        page;

    /* Parse the CGI stuff. */

    get_cgi_info(&ci);
    form_parameter = get_form_entries(&ci);

    /* Print HTML headers. */

    print_mimeheader("text/html");

    puts("<HTML>");
    puts("<HEAD>");
    puts("   <TITLE>Petidomo 2.2 Configuration Manager</TITLE>");
    puts("   <LINK REV=MADE HREF=\"mailto:simons@petidomo.com\">");
    puts("</HEAD>");
    puts("<BODY bgcolor=\"#ffffff\">");

#if 0
    puts("<H1>Debug</H1>\n");
    printf("ci.auth_type = %s<BR>\n", ci.auth_type);
    printf("ci.content_length = %d<BR>\n", ci.content_length);
    printf("ci.content_type = %s<BR>\n", ci.content_type);
    printf("ci.gateway_interface = %s<BR>\n", ci.gateway_interface);
    printf("ci.http_accept = %s<BR>\n", ci.http_accept);
    printf("ci.path_info = %s<BR>\n", ci.path_info);
    printf("ci.path_translated = %s<BR>\n", ci.path_translated);
    printf("ci.query_string = %s<BR>\n", ci.query_string);
    printf("ci.remote_addr = %s<BR>\n", ci.remote_addr);
    printf("ci.remote_host = %s<BR>\n", ci.remote_host);
    printf("ci.remote_ident = %s<BR>\n", ci.remote_ident);
    printf("ci.remote_user = %s<BR>\n", ci.remote_user);
    printf("ci.request_method = %s<BR>\n", ci.request_method);
    printf("ci.script_name = %s<BR>\n", ci.script_name);
    printf("ci.server_name = %s<BR>\n", ci.server_name);
    printf("ci.server_port = %s<BR>\n", ci.server_port);
    printf("ci.server_protocol = %s<BR>\n", ci.server_protocol);
    printf("ci.server_software = %s<BR>\n", ci.server_software);
    puts("<P>\n");
#endif

    /* Set our umask. */

    umask(S_IRWXO);		/* We don't care for "others". */

    /* Init Petidomo's internal stuff. */

    if (InitPetidomo() != 0) {
	puts("Failed to initialize my internals. Please contact the system");
	puts("administrator to remedy this situation.");
	exit(0);
    }
    MasterConfig = getMasterConfig();

    /* Go to 'petidomo' as euid. */

    SetUIDPetidomo();

    /* Find out from which page we have been called. */

    page = parmval(form_parameter, "page");
    if (page == NULL)
      printMainPage();
    else if (strcasecmp(page, "main") == 0)
      handleMainPage();
    else if (strcasecmp(page, "conf") == 0)
      handleConfPage();
    else if (strcasecmp(page, "listselect") == 0)
      handleListSelect();
    else if (strcasecmp(page, "listconf") == 0)
      handleListConfPage();
    else if (strcasecmp(page, "creatlist") == 0)
      handleCreateListPage();
    else if (strcasecmp(page, "remlist") == 0)
      handleRemoveListPage();
    else
      printMainPage();

    return 0;
}
